-- By MaTiOs95
-- Programuje i skriptuje na zamowienie :P
-- www.polski-mod.cba.pl
-- Cyklop
-- 01.02.2011

MAT = {};

function MAT.prerequisitesPresent(specializations)
    return true;
end;

function MAT:load(xmlFile)
	self.walekon = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.walekon#index"));
	self.walekoff = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.walekoff#index"));
	self.walwysun = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.walwysun#index"));
	self.walsamiec = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.walsamiec#index"));
	self.walsamica = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.walsamica#index"));
	self.obrot = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.obrot#index"));
	self.ramie = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ramie#index"));
	self.silownik1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.silownik1#index"));
	self.tlok1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tlok1#index"));
	self.ramie2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ramie2#index"));
	self.weze = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.weze#index"));
	self.silownik2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.silownik2#index"));
	self.tlok2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tlok2#index"));
	self.wajcha1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha1#index"));
	self.wajcha2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha2#index"));
	self.wajcha3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha3#index"));
	self.wajcha4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha4#index"));
	self.wajcha5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha5#index"));
	self.drzwi = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drzwi#index"));
	self.ludzik = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.ludzik#index"));
	if self.drzwi ~= nil then
		self.stopkaprawa = {};
		self.stopkaprawa.rama = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.stopkaprama#index"));
		self.stopkaprawa.stopa = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.stopkapstopa#index"));
		self.stopkaprawa.silownik = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.stopkapsilownik#index"));
		self.stopkaprawa.tlok = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.stopkaptlok#index"));
		
		self.stopkalewa = {};
		self.stopkalewa.rama = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.stopkalrama#index"));
		self.stopkalewa.stopa = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.stopkalstopa#index"));
		self.stopkalewa.silownik = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.stopkalsilownik#index"));
		self.stopkalewa.tlok = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.stopkaltlok#index"));
	end;
	hornSoundFile = Utils.getFilename("hydra.wav", self.baseDirectory);
	self.dzwiekid = createSample("hydraulika");
	loadSample(self.dzwiekid, hornSoundFile, false);
	hornSoundFile = Utils.getFilename("pompa.wav", self.baseDirectory);
	self.dzwiekid2 = createSample("pompka");
	loadSample(self.dzwiekid2, hornSoundFile, false);
	
	self.walekwidok = false;
	self.ludzikwidok = false;
	self.xp = 0;
	self.xp2 = 0;
end;

function MAT:delete()
end;

function MAT:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MAT:keyEvent(unicode, sym, modifier, isDown)
----------------------------------------------------------
	if sym == Input.KEY_KP_0 then
		self.pomoc = isDown;
	end;
----------------------------------------------------------
	if isDown and sym == Input.KEY_x then
		if self.zaczep == true then
			if self.walekwidok == true then
				if not self.walkrec then
					self.walekwidok = false;
				end;
			else
				self.walekwidok = true;
			end;
		end;
	end;
----------------------------------------------------------
	if sym == Input.KEY_9 then
		self.wsun = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_8 then
		self.wysun = isDown;
	end;
----------------------------------------------------------
	if isDown and sym == Input.KEY_b then
		if self.walekwidok == true then
			self.walkrec = not self.walkrec;
		end;
	end;
----------------------------------------------------------
	if sym == Input.KEY_KP_4 then
		self.obrotlewo = isDown;
		self.dzwiek = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_KP_6 then
		self.obrotprawo = isDown;
		self.dzwiek = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_KP_8 then
		self.ramiegora = isDown;
		self.dzwiek = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_KP_2 then
		self.ramiedol = isDown;
		self.dzwiek = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_KP_9 then
		self.ramie2gora = isDown;
		self.dzwiek = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_KP_3 then
		self.ramie2dol = isDown;
		self.dzwiek = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_6 then
		self.drzwiotworz = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_7 then
		self.drzwizamknij = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_KP_7 then
		self.stopkigora = isDown;
		self.dzwiek = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_KP_1 then
		self.stopkidol = isDown;
		self.dzwiek = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_pageup then
		self.up = isDown;
		self.dzwiek = isDown;
	end;
----------------------------------------------------------
	if sym == Input.KEY_pagedown then
		self.down = isDown;
		self.dzwiek = isDown;
	end;
----------------------------------------------------------
end;

function MAT:update(dt)
----------------------------------------------------------
	if self.walekwidok == true then
		setVisibility(self.walekon, true);
		setVisibility(self.walekoff, false);
	else
		setVisibility(self.walekon, false);
		setVisibility(self.walekoff, true);
	end;
----------------------------------------------------------
	local x, y, z = getTranslation(self.walwysun);
	if self.wsun then
		if z < 0 then
			setTranslation(self.walwysun, x, y, z+0.003);
		end;
	end;
	if self.wysun then
		if z > -0.4 then
			setTranslation(self.walwysun, x, y, z-0.003);
		end;
	end;
----------------------------------------------------------
	local x2, y2, z2 = getRotation(self.walsamiec);
	local x3, y3, z3 = getRotation(self.walsamica);
	if self.walkrec then
		rotate(self.walsamiec, x2, y2, dt*-0.02);
		rotate(self.walsamica, x3, y3, dt*-0.02);
	end;
----------------------------------------------------------
	local x4, y4, z4 = getRotation(self.obrot);
	local x5, y5, z5 = getRotation(self.ramie);
	local x6, y6, z6 = getRotation(self.silownik1);
	local x7, y7, z7 = getTranslation(self.tlok1);
	local x8, y8, z8 = getRotation(self.ramie2);
	local x9, y9, z9 = getRotation(self.weze);
	local x10, y10, z10 = getRotation(self.silownik2);
	local x11, y11, z11 = getTranslation(self.tlok2);
	local x12, y12, z12 = getRotation(self.wajcha1);
	local x13, y13, z13 = getRotation(self.wajcha2);
	local x14, y14, z14 = getRotation(self.wajcha3);
	local x15, y15, z15 = getRotation(self.drzwi);
	local x16, y16, z16 = getRotation(self.stopkaprawa.rama);
	local x17, y17, z17 = getRotation(self.stopkaprawa.stopa);
	local x18, y18, z18 = getRotation(self.stopkaprawa.silownik);
	local x19, y19, z19 = getTranslation(self.stopkaprawa.tlok);
	local x20, y20, z20 = getRotation(self.stopkalewa.rama);
	local x21, y21, z21 = getRotation(self.stopkalewa.stopa);
	local x22, y22, z22 = getRotation(self.stopkalewa.silownik);
	local x23, y23, z23 = getTranslation(self.stopkalewa.tlok);
	local x24, y24, z24 = getRotation(self.wajcha4);
	local x25, y25, z25 = getRotation(self.wajcha5);
--========================================================
	if self.walkrec then
----------------------------------------------------------
		if self.obrotlewo then
			if y4 < 1.919862 then
				setRotation(self.obrot, x4, y4+0.008, z4);
			end;
		end;
----------------------------------------------------------
		if self.obrotprawo then
			if y4 > -1.919862 then
				setRotation(self.obrot, x4, y4-0.008, z4);
			end;
		end;
----------------------------------------------------------
		if self.ramiegora then
			if x5 > -0.349065 then
				setRotation(self.ramie, x5-0.004, y5, z5);
				setTranslation(self.tlok1, x7, y7+0.004, z7);
				if x5 > 0.08726647 then
					setRotation(self.silownik1, x6+0.0004, y6, z6);
				else
					setRotation(self.silownik1, x6-0.00045, y6, z6);
				end;
			end;
		end;
----------------------------------------------------------
		if self.ramiedol then
			if x5 < 0.43633236 then
				setRotation(self.ramie, x5+0.004, y5, z5);
				setTranslation(self.tlok1, x7, y7-0.004, z7);
				if x5 > 0.08726647 then
					setRotation(self.silownik1, x6-0.0004, y6, z6);
				else
					setRotation(self.silownik1, x6+0.00045, y6, z6);
				end;
			end;
		end;
----------------------------------------------------------
		if self.ramie2gora then
			if x8 > -1.047197 then
				setRotation(self.ramie2, x8-0.004, y8, z8);
				setRotation(self.weze, x9-0.002, y9, z9);
				setTranslation(self.tlok2, x11, y11, z11+0.002);
				if x8 > -0.349065 then
					setRotation(self.silownik2, x10+0.00069997, y10, z10);
				end;
				if x8 < -0.78539825 then
					setRotation(self.silownik2, x10-0.00049997, y10, z10);
				end;
			end;
		end;
----------------------------------------------------------
		if self.ramie2dol then
			if x8 < 0.1745329 then
				setRotation(self.ramie2, x8+0.004, y8, z8);
				setRotation(self.weze, x9+0.002, y9, z9);
				setTranslation(self.tlok2, x11, y11, z11-0.002);
				if x8 > -0.349065 then
					setRotation(self.silownik2, x10-0.00069997, y10, z10);
				end;
				if x8 < -0.78539825 then
					setRotation(self.silownik2, x10+0.00049997, y10, z10);
				end;
			end;
		end;
----------------------------------------------------------
		if self.stopkigora then
			if z16 < 0.43633236 then
				setRotation(self.stopkaprawa.rama, x16, y16, z16+0.004);
				setRotation(self.stopkaprawa.stopa, x17, y17, z17-0.004);
				setRotation(self.stopkaprawa.silownik, x18, y18, z18+0.00352);
				setTranslation(self.stopkaprawa.tlok, x19-0.001, y19, z19);
				
				setRotation(self.stopkalewa.rama, x20, y20, z20-0.004);
				setRotation(self.stopkalewa.stopa, x21, y21, z21-0.004);
				setRotation(self.stopkalewa.silownik, x22, y22, z22-0.00352);
				setTranslation(self.stopkalewa.tlok, x23-0.001, y23, z23);
			end;
		end;
----------------------------------------------------------
		if self.stopkidol then
			if z16 > 0 then
				setRotation(self.stopkaprawa.rama, x16, y16, z16-0.004);
				setRotation(self.stopkaprawa.stopa, x17, y17, z17+0.004);
				setRotation(self.stopkaprawa.silownik, x18, y18, z18-0.00352);
				setTranslation(self.stopkaprawa.tlok, x19+0.001, y19, z19);
				
				setRotation(self.stopkalewa.rama, x20, y20, z20+0.004);
				setRotation(self.stopkalewa.stopa, x21, y21, z21+0.004);
				setRotation(self.stopkalewa.silownik, x22, y22, z22+0.00352);
				setTranslation(self.stopkalewa.tlok, x23+0.001, y23, z23);
			end;
		end;
----------------------------------------------------------
		if self.dzwiek then
			self.xp = self.xp - dt;
			if self.xp < 0 then
				playSample(self.dzwiekid, 1, 1, 0);
				self.xp = 1000;
			end;
		else
			self.xp = 0;
			stopSample(self.dzwiekid);
		end;
		
		self.xp2 = self.xp2 - dt;
		if self.xp2 < 0 then
			playSample(self.dzwiekid2, 1, 1, 0);
			self.xp2 = 3000;
		end;
----------------------------------------------------------
	else
		stopSample(self.dzwiekid2);
		self.xp2 = 0;
	end;
--========================================================
--++++++++++++++++++++++++++++++++++++++++++++++++++++++++
----------------------------------------------------------
	if self.obrotlewo then
		if x12 > -0.349065 then
			setRotation(self.wajcha1, x12-0.01, y12, z12);
		end;
	else
		if self.obrotprawo then
		else
			if x12 < 0 then
				setRotation(self.wajcha1, x12+0.01, y12, z12);
			end;
		end;
	end;
	
	if self.obrotprawo then
		if x12 < 0.349065 then
			setRotation(self.wajcha1, x12+0.01, y12, z12);
		end;
	else
		if self.obrotlewo then
		else
			if x12 > 0 then
				setRotation(self.wajcha1, x12-0.01, y12, z12);
			end;
		end;
	end;
----------------------------------------------------------
	if self.ramiedol then
		if x13 > -0.349065 then
			setRotation(self.wajcha2, x13-0.01, y13, z13);
		end;
	else
		if self.ramiegora then
		else
			if x13 < 0 then
				setRotation(self.wajcha2, x13+0.01, y13, z13);
			end;
		end;
	end;
	
	if self.ramiegora then
		if x13 < 0.349065 then
			setRotation(self.wajcha2, x13+0.01, y13, z13);
		end;
	else
		if self.ramiedol then
		else
			if x13 > 0 then
				setRotation(self.wajcha2, x13-0.01, y13, z13);
			end;
		end;
	end;
----------------------------------------------------------
	if self.ramie2dol then
		if x14 > -0.349065 then
			setRotation(self.wajcha3, x14-0.01, y14, z14);
		end;
	else
		if self.ramie2gora then
		else
			if x14 < 0 then
				setRotation(self.wajcha3, x14+0.01, y14, z14);
			end;
		end;
	end;
	
	if self.ramie2gora then
		if x14 < 0.349065 then
			setRotation(self.wajcha3, x14+0.01, y14, z14);
		end;
	else
		if self.ramie2dol then
		else
			if x14 > 0 then
				setRotation(self.wajcha3, x14-0.01, y14, z14);
			end;
		end;
	end;
----------------------------------------------------------
	if self.stopkidol then
		if x24 > -0.349065 then
			setRotation(self.wajcha4, x24-0.01, y24, z24);
		end;
	else
		if self.stopkigora then
		else
			if x24 < 0 then
				setRotation(self.wajcha4, x24+0.01, y24, z24);
			end;
		end;
	end;
	
	if self.stopkigora then
		if x24 < 0.349065 then
			setRotation(self.wajcha4, x24+0.01, y24, z24);
		end;
	else
		if self.stopkidol then
		else
			if x24 > 0 then
				setRotation(self.wajcha4, x24-0.01, y24, z24);
			end;
		end;
	end;
----------------------------------------------------------
	if self.down then
		if x25 > -0.349065 then
			setRotation(self.wajcha5, x25-0.01, y25, z25);
		end;
	else
		if self.up then
		else
			if x25 < 0 then
				setRotation(self.wajcha5, x25+0.01, y25, z25);
			end;
		end;
	end;
	
	if self.up then
		if x25 < 0.349065 then
			setRotation(self.wajcha5, x25+0.01, y25, z25);
		end;
	else
		if self.down then
		else
			if x25 > 0 then
				setRotation(self.wajcha5, x25-0.01, y25, z25);
			end;
		end;
	end;
----------------------------------------------------------
--++++++++++++++++++++++++++++++++++++++++++++++++++++++++
----------------------------------------------------------
	if self.drzwiotworz then
		if y15 < 3.36848582 then
			setRotation(self.drzwi, x15, y15+0.01, z15);
		end;
	end;
	
	if self.drzwizamknij then
		if y15 > 0 then
			setRotation(self.drzwi, x15, y15-0.01, z15);
		end;
	end;
----------------------------------------------------------
end;

function MAT:draw()
	g_currentMission:addExtraPrintText("Klawisz: NUM_0                                POMOC");
	if self.pomoc then
		--setTextColor(0,0,1,1);
		--renderText(0, 0.66, 0.02, "-------------------------------------");
		
		setTextColor(0,1,0,1);
		setTextBold(true);
		renderText(0, 0.64, 0.02, "By -> MaTiOs95 & xxMichalLsxx");
		
		--setTextColor(0,0,1,1);
		setTextBold(false);
		--renderText(0, 0.62, 0.02, "-------------------------------------");
		
		setTextColor(0,1,0,1);
		renderText(0, 0.60, 0.02, "------------>--KLAWISZOLOGIA--<-----------");
		
		setTextColor(1,1,0,1);
		renderText(0, 0.58, 0.02, "Klawisz x: Podczepianie/Odczepianie przekaznika");
		renderText(0, 0.56, 0.02, "Klawisz b: Wlanczanie/Wylanczanie pompy");
		renderText(0, 0.54, 0.02, "Klawisz 8: Wydluzanie przekaznika");
		renderText(0, 0.52, 0.02, "Klawisz 9: Wsuwanie przekaznika");
		renderText(0, 0.50, 0.02, "Klawisz 6: Otwieranie drzwi");
		renderText(0, 0.48, 0.02, "Klawisz 7: Zamykanie drzwi");
		renderText(0, 0.46, 0.02, "Klawisz PageUp: Zaciskanie widel/lyzki");
		renderText(0, 0.44, 0.02, "Klawisz PageDown: Rozkladanie widel/lyzki ");
		renderText(0, 0.42, 0.02, "Klawisz Num7: Podnoszenie stopek");
		renderText(0, 0.40, 0.02, "Klawisz Num1: Opuszczanie stopek");
		renderText(0, 0.38, 0.02, "Klawisz Num8: Podnoszenie ramienia");
		renderText(0, 0.36, 0.02, "Klawisz Num2: Opuszczanie ramienia");
		renderText(0, 0.34, 0.02, "Klawisz Num9: Podnoszenie 2 ramienia");
		renderText(0, 0.32, 0.02, "Klawisz Num3: Opuszczanie 2 ramienia");
		renderText(0, 0.30, 0.02, "Klawisz Num6: Obrot w prawo");
		renderText(0, 0.28, 0.02, "Klawisz Num4: Obrot w lewo");
		
		--setTextColor(0,0,1,1);
		--renderText(0, 0.26, 0.02, "-------------------------------------");
		
		setTextColor(0,1,0,1);
		setTextBold(true);
		renderText(0, 0.24, 0.02, "Zapraszamy --> WWW.POLSKI-MOD.CBA.PL");
		
		--setTextColor(0,0,1,1);
		--setTextBold(false);
		--renderText(0, 0.22, 0.02, "-------------------------------------");
	end;
end;

function MAT:onLeave()
	stopSample(self.dzwiekid);
end;

function MAT:onEnter()
	setVisibility(self.ludzik, false);
end;

function MAT:onDetach()
	self.walekwidok = false;
	if self.walkrec then
		self.walkrec = not self.walkrec;
	end;
	stopSample(self.dzwiekid);
	self.zaczep = false;
end;

function MAT:onAttach(attacherVehicle)
	self.zaczep = true;
end;

function MAT:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

-- KLAWISZOLOGIA
-- x - zapinanie/odpinanie walka +
-- b - wlaczenie/ wylanczanie walka +
-- 8 - wysuwanie walka +
-- 9 - wsuwanie walka +
-- num4 - obrot w lewo
-- num6 - obrot w prawo
-- num8 - ramie gora + 
-- num2 - ramie dol +
-- num9 - ramie2 gora +
-- num3 - ramie2 dol +
-- num7 - stopki gora +
-- num1 - stopki dol +
-- 6 - drzwi otwieranie +
-- 7 - drzwi zamykanie +
-- pageup - zamykanie lyzki/widel +
-- pagedown - otwieranie lyzki/widel +

MAT2 = {};

function MAT2.prerequisitesPresent(specializations)
    return true;
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:load(xmlFile)
	self.lyga1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lyga1#index"));
	self.lyga2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lyga2#index"));
	self.silownik = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.silownik#index"));
	self.tlok = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tlok#index"));
	self.zsyp = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.zsyp#index"));
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:delete()
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:mouseEvent(posX, posY, isDown, isUp, button)
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:keyEvent(unicode, sym, modifier, isDown)
	if sym == Input.KEY_pageup then
		self.up = isDown;
	end;
	if sym == Input.KEY_pagedown then
		self.down = isDown;
	end;
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:update(dt)
	local x1, y1, z1 = getRotation(self.lyga1);
	local x2, y2, z2 = getRotation(self.lyga2);
	local x3, y3, z3 = getRotation(self.silownik);
	local x4, y4, z4 = getRotation(self.zsyp);
	local x5, y5, z5 = getTranslation(self.tlok);
	
	if self.up then
		if z1 < 1.13446413 then
			setRotation(self.lyga1, x1, y1, z1+0.01);
			setRotation(self.lyga2, x2, y2, z2-0.01);
			setRotation(self.silownik, x3, y3, z3+0.00184615);
			setRotation(self.zsyp, x4-0.0277, y4, z4);
			setTranslation(self.tlok, x5-0.002, y5, z5);
		end;
	end;
	if self.down then
		if z1 > 0 then
			setRotation(self.lyga1, x1, y1, z1-0.01);
			setRotation(self.lyga2, x2, y2, z2+0.01);
			setRotation(self.silownik, x3, y3, z3-0.00184615);
			setRotation(self.zsyp, x4+0.0277, y4, z4);
			setTranslation(self.tlok, x5+0.002, y5, z5);
		end;
	end;
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:draw()
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:onLeave()
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:onEnter()
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:onDetach()
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:onAttach(attacherVehicle)
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT2:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////

MAT3 = {};

function MAT3.prerequisitesPresent(specializations)
    return true;
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:load(xmlFile)
	self.lyga1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lyga1#index"));
	self.lyga2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.lyga2#index"));
	self.silownik = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.silownik#index"));
	self.tlok = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tlok#index"));
	self.zsyp = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.zsyp#index"));
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:delete()
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:mouseEvent(posX, posY, isDown, isUp, button)
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:keyEvent(unicode, sym, modifier, isDown)
	if sym == Input.KEY_pageup then
		self.up = isDown;
	end;
	if sym == Input.KEY_pagedown then
		self.down = isDown;
	end;
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:update(dt)
	local x1, y1, z1 = getRotation(self.lyga1);
	local x2, y2, z2 = getRotation(self.lyga2);
	local x3, y3, z3 = getRotation(self.silownik);
	local x4, y4, z4 = getRotation(self.zsyp);
	local x5, y5, z5 = getTranslation(self.tlok);
	
	if self.up then
		if z1 < 1.48353002 then
			setRotation(self.lyga1, x1, y1, z1+0.01);
			setRotation(self.lyga2, x2, y2, z2-0.01);
			setRotation(self.silownik, x3, y3, z3+0.00184615);
			setRotation(self.zsyp, x4-0.0277, y4, z4);
			setTranslation(self.tlok, x5-0.002, y5, z5);
		end;
	end;
	if self.down then
		if z1 > 0 then
			setRotation(self.lyga1, x1, y1, z1-0.01);
			setRotation(self.lyga2, x2, y2, z2+0.01);
			setRotation(self.silownik, x3, y3, z3-0.00184615);
			setRotation(self.zsyp, x4+0.0277, y4, z4);
			setTranslation(self.tlok, x5+0.002, y5, z5);
		end;
	end;
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:draw()
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:onLeave()
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:onEnter()
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:onDetach()
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:onAttach(attacherVehicle)
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////
function MAT3:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
--///////////////////////////////////////////////////////////////////////////////////////////////////